'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _styles = require('./styles');

var _styles2 = _interopRequireDefault(_styles);

var _combineStyles = require('../internal/combine-styles');

var _combineStyles2 = _interopRequireDefault(_combineStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var root = function root(type, overrideStyle) {
  return (0, _combineStyles2.default)((0, _combineStyles2.default)(_styles2.default.root, _styles2.default[type]), overrideStyle);
};

var icon = function icon(overrideStyle) {
  return (0, _combineStyles2.default)(_styles2.default.icon, overrideStyle);
};

var text = function text() {
  var hideAlert = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
  var overrideStyle = arguments[1];

  var style = _styles2.default.text;

  if (hideAlert) {
    style = (0, _combineStyles2.default)(style, { paddingRight: '40px' });
  }

  return (0, _combineStyles2.default)(style, overrideStyle);
};

var button = function button(overrideStyle) {
  return (0, _combineStyles2.default)(_styles2.default.button, overrideStyle);
};

exports.default = {
  root: root,
  icon: icon,
  text: text,
  button: button
};
module.exports = exports.default;