'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _getStyles = require('./get-styles');

var _getStyles2 = _interopRequireDefault(_getStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var displayName = 'AppHeader';

var propTypes = {
  /** Title text (your app's name) */
  text: _propTypes2.default.node,
  /** Icon (your app's icon) */
  icon: _propTypes2.default.node,
  /** Button on the right side of the AppHeader */
  rightButton: _propTypes2.default.node,
  /** Override the styles of the root element */
  style: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  /** Override the styles of the text element */
  textStyle: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  /** Override the styles of the icon element */
  iconStyle: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  /** Override the styles of the right button */
  rightButtonStyle: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  /** Button on the left side of the AppHeader */
  leftButton: _propTypes2.default.node,
  /** Override the styles of the left button */
  leftButtonStyle: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  color: _propTypes2.default.string.isRequired
};

var defaultProps = {
  text: null,
  style: {},
  textStyle: {},
  iconStyle: {},
  rightButtonStyle: {},
  icon: null,
  rightButton: null,
  leftButton: null,
  leftButtonStyle: {}
};

/** Your app's header */
var AppHeader = function AppHeader(_ref) {
  var text = _ref.text,
      icon = _ref.icon,
      rightButton = _ref.rightButton,
      style = _ref.style,
      iconStyle = _ref.iconStyle,
      textStyle = _ref.textStyle,
      rightButtonStyle = _ref.rightButtonStyle,
      leftButton = _ref.leftButton,
      leftButtonStyle = _ref.leftButtonStyle,
      color = _ref.color,
      custom = _objectWithoutProperties(_ref, ['text', 'icon', 'rightButton', 'style', 'iconStyle', 'textStyle', 'rightButtonStyle', 'leftButton', 'leftButtonStyle', 'color']);

  return _react2.default.createElement(
    'header',
    _extends({ style: _getStyles2.default.root(color, leftButton, rightButton, style) }, custom),
    leftButton ? _react2.default.createElement(
      'div',
      { style: _getStyles2.default.leftButton(leftButtonStyle) },
      leftButton
    ) : null,
    icon ? _react2.default.createElement(
      'div',
      { style: _getStyles2.default.icon(iconStyle) },
      icon
    ) : null,
    text ? _react2.default.createElement(
      'h1',
      { style: _getStyles2.default.text(textStyle) },
      text
    ) : null,
    rightButton ? _react2.default.createElement(
      'div',
      { style: _getStyles2.default.rightButton(rightButtonStyle) },
      rightButton
    ) : null
  );
};

AppHeader.displayName = displayName;
AppHeader.propTypes = propTypes;
AppHeader.defaultProps = defaultProps;

exports.default = AppHeader;
module.exports = exports.default;