'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _styles = require('./styles');

var _styles2 = _interopRequireDefault(_styles);

var _combineStyles = require('../internal/combine-styles');

var _combineStyles2 = _interopRequireDefault(_combineStyles);

var _colors = require('../settings/colors');

var _colors2 = _interopRequireDefault(_colors);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var root = function root() {
  var color = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _colors2.default.theme;
  var left = arguments[1];
  var right = arguments[2];
  var overrideStyle = arguments[3];

  var style = (0, _combineStyles2.default)(_styles2.default.root, { backgroundColor: color });

  if (left) {
    style = (0, _combineStyles2.default)(style, { paddingLeft: '56px' });
  }

  if (right) {
    style = (0, _combineStyles2.default)(style, { paddingRight: '56px' });
  }

  return (0, _combineStyles2.default)(style, overrideStyle);
};

var text = function text(overrideStyle) {
  return (0, _combineStyles2.default)(_styles2.default.text, overrideStyle);
};

var leftButton = function leftButton(overrideStyle) {
  return (0, _combineStyles2.default)(_styles2.default.leftButton, overrideStyle);
};

var rightButton = function rightButton(overrideStyle) {
  return (0, _combineStyles2.default)(_styles2.default.rightButton, overrideStyle);
};

var icon = function icon(overrideStyle) {
  return (0, _combineStyles2.default)(_styles2.default.icon, overrideStyle);
};

exports.default = {
  root: root,
  text: text,
  leftButton: leftButton,
  rightButton: rightButton,
  icon: icon
};
module.exports = exports.default;