'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _colors = require('../settings/colors');

var _colors2 = _interopRequireDefault(_colors);

var _styles = require('../settings/styles');

var _styles2 = _interopRequireDefault(_styles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styleSheet = {
  root: {
    backgroundColor: _colors2.default.theme,
    boxShadow: _styles2.default.depthShadows[0],
    boxSizing: 'border-box',
    height: '56px',
    paddingTop: '8px',
    paddingRight: '16px',
    paddingBottom: '8px',
    paddingLeft: '16px',
    position: 'relative',
    width: '100%',
    zIndex: '1',
    display: 'flex',
    alignItems: 'center',
    transition: 'background .3s ease-in-out'
  },
  text: {
    color: _colors2.default.white,
    fontSize: '24px',
    fontWeight: 'inherit',
    lineHeight: '40px',
    margin: 0,
    textDecoration: 'none',
    overflow: 'hidden',
    textOverflow: 'ellipsis',
    whiteSpace: 'nowrap'
  },
  leftButton: {
    position: 'absolute',
    left: '8px',
    top: '8px'
  },
  rightButton: {
    position: 'absolute',
    right: '8px',
    top: '8px'
  },
  icon: {
    height: '100%',
    marginRight: '16px'
  }
};

exports.default = styleSheet;
module.exports = exports.default;