'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _getStyles = require('./get-styles');

var _getStyles2 = _interopRequireDefault(_getStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var displayName = 'Avatar';

var propTypes = {
  /** Path to user's profile image */
  image: _propTypes2.default.string.isRequired,
  /** Path to default image. This image will be shown if the image path doesn't resolve */
  defaultImage: _propTypes2.default.string,
  /** Override the styles of the root element */
  style: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  /** An user's status. One of the following: ["online", "away", "offline"] */
  status: _propTypes2.default.oneOf(['online', 'away', 'offline', '']),
  /** Override the styles of the status indicator */
  statusStyle: _propTypes2.default.object // eslint-disable-line react/forbid-prop-types
};

var defaultProps = {
  style: {},
  status: '',
  statusStyle: {},
  defaultImage: null
};

/** A user's profile image */
var Avatar = function Avatar(_ref) {
  var image = _ref.image,
      defaultImage = _ref.defaultImage,
      style = _ref.style,
      status = _ref.status,
      statusStyle = _ref.statusStyle,
      custom = _objectWithoutProperties(_ref, ['image', 'defaultImage', 'style', 'status', 'statusStyle']);

  return _react2.default.createElement(
    'section',
    _extends({ style: _getStyles2.default.root(image, defaultImage, style) }, custom),
    status ? _react2.default.createElement('div', { style: _getStyles2.default.status(status, statusStyle) }) : null
  );
};

Avatar.displayName = displayName;
Avatar.propTypes = propTypes;
Avatar.defaultProps = defaultProps;

exports.default = Avatar;
module.exports = exports.default;