'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _isNumber = require('lodash/isNumber');

var _isNumber2 = _interopRequireDefault(_isNumber);

var _getStyles = require('./get-styles');

var _getStyles2 = _interopRequireDefault(_getStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

/** Used for displaying a (notification) counter */
var Badge = function Badge(_ref) {
  var value = _ref.value,
      maxValue = _ref.maxValue,
      inverted = _ref.inverted,
      style = _ref.style,
      color = _ref.color,
      custom = _objectWithoutProperties(_ref, ['value', 'maxValue', 'inverted', 'style', 'color']);

  var content = value;

  if ((0, _isNumber2.default)(maxValue) && value > maxValue) {
    content = maxValue + '+';
  }

  return _react2.default.createElement(
    'span',
    _extends({ style: _getStyles2.default.root(color, inverted, style) }, custom),
    content
  );
};

Badge.displayName = 'Badge';

Badge.propTypes = {
  /** The badge's value */
  value: _propTypes2.default.number.isRequired,
  /** Override the styles of the root element */
  style: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  /** Inverts color */
  inverted: _propTypes2.default.bool,
  /** Maximum value that will be shown.
   * This will result in `${maxValue}+` if value exceeds maxValue.
   */
  maxValue: _propTypes2.default.number,
  color: _propTypes2.default.string.isRequired
};

Badge.defaultProps = {
  style: {},
  inverted: false,
  maxValue: null
};

exports.default = Badge;
module.exports = exports.default;