'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styles = require('./styles');

var _styles2 = _interopRequireDefault(_styles);

var _getStyles = require('./get-styles');

var _getStyles2 = _interopRequireDefault(_getStyles);

var _media = require('../media');

var _media2 = _interopRequireDefault(_media);

var _button = require('../button');

var _button2 = _interopRequireDefault(_button);

var _iconClose = require('../icons/icon-close');

var _iconClose2 = _interopRequireDefault(_iconClose);

var _colors = require('../settings/colors');

var _colors2 = _interopRequireDefault(_colors);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var displayName = 'Banner';

var propTypes = {
  /** Content of the Banner */
  content: _propTypes2.default.shape({
    /** 728x90 banner */
    desktop: _propTypes2.default.node.isRequired,
    /** 320x50 banner */
    mobile: _propTypes2.default.node.isRequired
  }).isRequired,
  /**
   * Callback fired when the close button is clicked
   *
   * function(event: object) => void
   */
  hideBanner: _propTypes2.default.func,
  /** Override the styles of the root element */
  style: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  /** Toggle banner open */
  open: _propTypes2.default.bool
};

var defaultProps = {
  style: {},
  open: false,
  hideBanner: null
};

/** 728x90 and 320x50 banners */

var Banner = function (_Component) {
  _inherits(Banner, _Component);

  function Banner() {
    _classCallCheck(this, Banner);

    var _this = _possibleConstructorReturn(this, (Banner.__proto__ || Object.getPrototypeOf(Banner)).call(this));

    _this.setMedia = function (matches) {
      var type = _this.state.type;


      if (!matches.small && type === 'desktop') {
        _this.setState({
          type: 'mobile'
        });
      }

      if (matches.small && type === 'mobile') {
        _this.setState({
          type: 'desktop'
        });
      }
    };

    _this.state = {
      type: 'desktop'
    };
    return _this;
  }

  _createClass(Banner, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          style = _props.style,
          content = _props.content,
          hideBanner = _props.hideBanner,
          open = _props.open;
      var type = this.state.type;


      if (!open) {
        return null;
      }

      var query = {
        small: '(min-width: 728px)'
      };

      return _react2.default.createElement(
        'section',
        { style: _styles2.default.wrapper },
        _react2.default.createElement(
          'section',
          { style: _getStyles2.default.root(type, style) },
          content[type],
          hideBanner ? _react2.default.createElement(
            _button2.default,
            { iconButton: true, onClick: hideBanner, style: _styles2.default.button },
            _react2.default.createElement(_iconClose2.default, { color: _colors2.default.white })
          ) : null
        ),
        _react2.default.createElement(_media2.default, { query: query, onChange: this.setMedia })
      );
    }
  }]);

  return Banner;
}(_react.Component);

Banner.displayName = displayName;
Banner.propTypes = propTypes;
Banner.defaultProps = defaultProps;

exports.default = Banner;
module.exports = exports.default;