'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _colors = require('../settings/colors');

var _colors2 = _interopRequireDefault(_colors);

var _darken = require('../internal/darken');

var _darken2 = _interopRequireDefault(_darken);

var _styles = require('../settings/styles');

var _styles2 = _interopRequireDefault(_styles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
  root: {
    position: 'relative',
    backgroundColor: _colors2.default.white,
    borderRadius: '4px',
    boxShadow: _styles2.default.depthShadows[0],
    overflow: 'hidden'
  },
  wrapper: {
    width: '100%',
    height: '1px',
    position: 'absolute',
    top: '0',
    left: '0',
    display: 'flex',
    flexDirection: 'row',
    justifyContent: 'center'
  },
  desktop: {
    width: '728px',
    height: '90px'
  },
  mobile: {
    width: '320px',
    height: '50px'
  },
  button: {
    position: 'absolute',
    top: '4px',
    right: '4px',
    boxShadow: _styles2.default.depthShadows[0],
    backgroundColor: _colors2.default.primaryText,

    ':hover': {
      backgroundColor: (0, _darken2.default)(_colors2.default.primaryText, 0.15)
    },
    ':active': {
      backgroundColor: (0, _darken2.default)(_colors2.default.primaryText, 0.25)
    }
  }
};
module.exports = exports.default;