'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _getStyles = require('./get-styles');

var _getStyles2 = _interopRequireDefault(_getStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var displayName = 'Button';

var propTypes = {
  /** Content of the button */
  children: _propTypes2.default.node.isRequired,
  /**
   * Callback fired when the Button is clicked
   *
   * function(event: object) => void
   */
  onClick: _propTypes2.default.func,
  /** Override the styles of the root element */
  style: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  /** Toggle IconButton type */
  iconButton: _propTypes2.default.bool,
  /** Inverts color */
  inverted: _propTypes2.default.bool,
  /** Disables the button */
  disabled: _propTypes2.default.bool,
  /** Toggle FlatButton type */
  flatButton: _propTypes2.default.bool,
  color: _propTypes2.default.string.isRequired
};

var defaultProps = {
  style: {},
  iconButton: false,
  inverted: false,
  onClick: null,
  disabled: false,
  flatButton: false
};

/** General purpose button with three types */
var Button = function Button(_ref) {
  var children = _ref.children,
      onClick = _ref.onClick,
      iconButton = _ref.iconButton,
      inverted = _ref.inverted,
      style = _ref.style,
      disabled = _ref.disabled,
      flatButton = _ref.flatButton,
      color = _ref.color,
      custom = _objectWithoutProperties(_ref, ['children', 'onClick', 'iconButton', 'inverted', 'style', 'disabled', 'flatButton', 'color']);

  return _react2.default.createElement(
    'button',
    _extends({
      onClick: onClick,
      style: _getStyles2.default.root(color, inverted, iconButton, disabled, flatButton, style),
      disabled: disabled,
      type: 'button'
    }, custom),
    children
  );
};

Button.displayName = displayName;
Button.propTypes = propTypes;
Button.defaultProps = defaultProps;

exports.default = Button;
module.exports = exports.default;