'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _getStyles = require('./get-styles');

var _getStyles2 = _interopRequireDefault(_getStyles);

var _avatar = require('../avatar');

var _avatar2 = _interopRequireDefault(_avatar);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

/** A Card is a piece of paper with unique related data */
var CardHeader = function CardHeader(_ref) {
  var style = _ref.style,
      title = _ref.title,
      headerStyle = _ref.headerStyle,
      titleStyle = _ref.titleStyle,
      subtitle = _ref.subtitle,
      subtitleStyle = _ref.subtitleStyle,
      avatar = _ref.avatar,
      avatarStyle = _ref.avatarStyle,
      custom = _objectWithoutProperties(_ref, ['style', 'title', 'headerStyle', 'titleStyle', 'subtitle', 'subtitleStyle', 'avatar', 'avatarStyle']);

  return _react2.default.createElement(
    'header',
    _extends({ style: _getStyles2.default.root(style) }, custom),
    avatar ? _react2.default.createElement(_avatar2.default, { image: avatar, style: _getStyles2.default.avatar(avatarStyle) }) : null,
    _react2.default.createElement(
      'div',
      { style: _getStyles2.default.header(avatar, headerStyle) },
      _react2.default.createElement(
        'h1',
        { style: _getStyles2.default.title(titleStyle) },
        title
      ),
      subtitle ? _react2.default.createElement(
        'h2',
        { style: _getStyles2.default.subtitle(subtitleStyle) },
        subtitle
      ) : null
    )
  );
};

CardHeader.displayName = 'CardHeader';

CardHeader.propTypes = {
  /** Override the styles of the root element */
  style: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  /** Override the styles of the header element */
  headerStyle: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  /** Override the styles of the title element */
  titleStyle: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  /** The CardHeader's title */
  title: _propTypes2.default.node.isRequired,
  /** Override the styles of the subtitle element */
  subtitleStyle: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  /** The CardHeader's subtitle */
  subtitle: _propTypes2.default.node,
  /** Path to an Avatar image */
  avatar: _propTypes2.default.string,
  /** Override the styles of the subtitle element */
  avatarStyle: _propTypes2.default.object // eslint-disable-line react/forbid-prop-types
};

CardHeader.defaultProps = {
  style: {},
  headerStyle: {},
  titleStyle: {},
  subtitleStyle: {},
  subtitle: null,
  avatar: '',
  avatarStyle: {}
};

exports.default = CardHeader;
module.exports = exports.default;