'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _styles = require('./styles');

var _styles2 = _interopRequireDefault(_styles);

var _combineStyles = require('../internal/combine-styles');

var _combineStyles2 = _interopRequireDefault(_combineStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var root = function root(overrideStyle) {
  return (0, _combineStyles2.default)(_styles2.default.root, overrideStyle);
};

var header = function header() {
  var avatar = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
  var overrideStyle = arguments[1];

  var style = {};

  if (avatar) {
    style = (0, _combineStyles2.default)(style, { maxWidth: 'calc(100% - 56px)' });
  }

  return (0, _combineStyles2.default)(style, overrideStyle);
};

var title = function title(overrideStyle) {
  return (0, _combineStyles2.default)(_styles2.default.title, overrideStyle);
};

var subtitle = function subtitle(overrideStyle) {
  return (0, _combineStyles2.default)(_styles2.default.subtitle, overrideStyle);
};

var avatar = function avatar(overrideStyle) {
  return (0, _combineStyles2.default)(_styles2.default.avatar, overrideStyle);
};

exports.default = {
  root: root,
  header: header,
  title: title,
  subtitle: subtitle,
  avatar: avatar
};
module.exports = exports.default;