'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _getStyles = require('./get-styles');

var _getStyles2 = _interopRequireDefault(_getStyles);

var _styles = require('./styles');

var _styles2 = _interopRequireDefault(_styles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

/** A channel's header */
var ChannelHeader = function ChannelHeader(_ref) {
  var name = _ref.name,
      rightButton = _ref.rightButton,
      leftButton = _ref.leftButton,
      style = _ref.style,
      leftButtonStyle = _ref.leftButtonStyle,
      textStyle = _ref.textStyle,
      rightButtonStyle = _ref.rightButtonStyle,
      secondaryText = _ref.secondaryText,
      secondaryTextStyle = _ref.secondaryTextStyle,
      color = _ref.color,
      custom = _objectWithoutProperties(_ref, ['name', 'rightButton', 'leftButton', 'style', 'leftButtonStyle', 'textStyle', 'rightButtonStyle', 'secondaryText', 'secondaryTextStyle', 'color']);

  return _react2.default.createElement(
    'header',
    _extends({ style: _getStyles2.default.root(style) }, custom),
    leftButton ? _react2.default.createElement(
      'div',
      { style: _getStyles2.default.leftButton(leftButtonStyle) },
      leftButton
    ) : null,
    _react2.default.createElement(
      'section',
      { style: _styles2.default.textContainer },
      _react2.default.createElement(
        'h1',
        { style: _getStyles2.default.text(textStyle) },
        name
      ),
      secondaryText ? _react2.default.createElement(
        'h2',
        { style: _getStyles2.default.secondaryText(color, secondaryTextStyle) },
        secondaryText
      ) : null
    ),
    rightButton ? _react2.default.createElement(
      'div',
      { style: _getStyles2.default.rightButton(rightButtonStyle) },
      rightButton
    ) : null
  );
};

ChannelHeader.displayName = 'ChannelHeader';

ChannelHeader.propTypes = {
  /** The channel's name */
  name: _propTypes2.default.node.isRequired,
  /** Optional text to display below `name` */
  secondaryText: _propTypes2.default.node,
  /** Button on the right side of the ChannelHeader */
  rightButton: _propTypes2.default.node,
  /** Button on the left side of the ChannelHeader */
  leftButton: _propTypes2.default.node,
  /** Override the styles of the root element */
  style: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  /** Override the styles of the text element */
  textStyle: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  /** Override the styles of the text element */
  secondaryTextStyle: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  /** Override the styles of the leftButton element */
  leftButtonStyle: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  /** Override the styles of the rightButton element */
  rightButtonStyle: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  color: _propTypes2.default.string.isRequired
};

ChannelHeader.defaultProps = {
  style: {},
  textStyle: {},
  secondaryTextStyle: {},
  rightButtonStyle: {},
  leftButtonStyle: {},
  rightButton: null,
  leftButton: null,
  secondaryText: null
};

exports.default = ChannelHeader;
module.exports = exports.default;