'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _styles = require('./styles');

var _styles2 = _interopRequireDefault(_styles);

var _combineStyles = require('../internal/combine-styles');

var _combineStyles2 = _interopRequireDefault(_combineStyles);

var _colors = require('../settings/colors');

var _colors2 = _interopRequireDefault(_colors);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var root = function root(overrideStyle) {
  return (0, _combineStyles2.default)(_styles2.default.root, overrideStyle);
};

var text = function text(overrideStyle) {
  return (0, _combineStyles2.default)(_styles2.default.text, overrideStyle);
};

var secondaryText = function secondaryText() {
  var color = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _colors2.default.theme;
  var overrideStyle = arguments[1];

  var style = (0, _combineStyles2.default)(_styles2.default.secondaryText, { color: color });

  return (0, _combineStyles2.default)(style, overrideStyle);
};

var leftButton = function leftButton(overrideStyle) {
  return (0, _combineStyles2.default)(_styles2.default.leftButton, overrideStyle);
};

var rightButton = function rightButton(overrideStyle) {
  return (0, _combineStyles2.default)(_styles2.default.rightButton, overrideStyle);
};

exports.default = {
  root: root,
  text: text,
  secondaryText: secondaryText,
  leftButton: leftButton,
  rightButton: rightButton
};
module.exports = exports.default;