'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _styles = require('./styles');

var _styles2 = _interopRequireDefault(_styles);

var _combineStyles = require('../internal/combine-styles');

var _combineStyles2 = _interopRequireDefault(_combineStyles);

var _colors = require('../settings/colors');

var _colors2 = _interopRequireDefault(_colors);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var root = function root() {
  var color = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _colors2.default.theme;
  var overrideStyles = arguments[1];

  var style = _styles2.default.root;

  style = (0, _combineStyles2.default)(style, { ':hover': { color: color } });

  return (0, _combineStyles2.default)(style, overrideStyles);
};

var input = function input(overrideStyles) {
  return (0, _combineStyles2.default)(_styles2.default.input, overrideStyles);
};

var label = function label(overrideStyles) {
  return (0, _combineStyles2.default)(_styles2.default.label, overrideStyles);
};

var icon = function icon(overrideStyles) {
  return (0, _combineStyles2.default)(_styles2.default.icon, overrideStyles);
};

var unchecked = function unchecked(overrideStyles) {
  return (0, _combineStyles2.default)(_styles2.default.unchecked, overrideStyles);
};

exports.default = {
  root: root,
  input: input,
  label: label,
  icon: icon,
  unchecked: unchecked
};
module.exports = exports.default;