'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _styles = require('./styles');

var _styles2 = _interopRequireDefault(_styles);

var _combineStyles = require('../internal/combine-styles');

var _combineStyles2 = _interopRequireDefault(_combineStyles);

var _colors = require('../settings/colors');

var _colors2 = _interopRequireDefault(_colors);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var root = function root(overrideStyle) {
  return (0, _combineStyles2.default)(_styles2.default.root, overrideStyle);
};
var header = function header(overrideStyle) {
  return (0, _combineStyles2.default)(_styles2.default.header, overrideStyle);
};
var commands = function commands(overrideStyle) {
  return (0, _combineStyles2.default)(_styles2.default.commands, overrideStyle);
};

var command = function command() {
  var color = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _colors2.default.theme;
  var active = arguments[1];
  var overrideStyle = arguments[2];

  var style = _styles2.default.command;

  if (active) {
    style = (0, _combineStyles2.default)(style, { backgroundColor: color, color: _colors2.default.white });
  }

  return (0, _combineStyles2.default)(style, overrideStyle);
};

var title = function title(overrideStyle) {
  return (0, _combineStyles2.default)(_styles2.default.title, overrideStyle);
};
var description = function description(overrideStyle) {
  return (0, _combineStyles2.default)(_styles2.default.description, overrideStyle);
};

exports.default = {
  root: root,
  header: header,
  commands: commands,
  command: command,
  title: title,
  description: description
};
module.exports = exports.default;