'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _colors = require('../settings/colors');

var _colors2 = _interopRequireDefault(_colors);

var _styles = require('../settings/styles');

var _styles2 = _interopRequireDefault(_styles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
  root: {
    borderRadius: '4px',
    backgroundColor: _colors2.default.white,
    overflow: 'hidden',
    width: '100%',
    height: '200px',
    boxShadow: _styles2.default.depthShadows[0]
  },
  header: {
    backgroundColor: _colors2.default.background,
    color: _colors2.default.secondaryText,
    transition: 'background .3s ease-in-out',
    padding: '8px',
    height: '32px',
    fontSize: '16px',
    lineHeight: '16px',
    boxSizing: 'border-box',
    fontWeight: 'bolder'
  },
  commands: {
    height: 'calc(100% - 32px)',
    overflowY: 'scroll'
  },
  command: {
    padding: '8px 16px 8px 8px',
    margin: 0,
    fontSize: '14px',
    cursor: 'pointer',
    color: _colors2.default.primaryText,
    display: 'flex',
    alignItems: 'center',
    justifyContent: 'space-between',
    backgroundColor: _colors2.default.white
  },
  title: {
    fontWeight: 'bolder',
    marginRight: '4px',
    fontSize: '14px',
    lineHeight: '14px'
  },
  description: {
    fontStyle: 'italic',
    fontWeight: 'inherit',
    fontSize: '14px',
    lineHeight: '14px',
    float: 'right'
  },
  titleContainer: {
    display: 'flex',
    alignItems: 'center'
  },
  avatarContainer: {
    width: '20px',
    height: '20px',
    marginRight: '8px'
  },
  avatar: {
    width: '100%',
    height: '100%'
  }
};
module.exports = exports.default;