'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _getStyles = require('./get-styles');

var _getStyles2 = _interopRequireDefault(_getStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var propTypes = {
  /** Optional divider text */
  text: _propTypes2.default.node,
  /** Override the styles of the root element */
  style: _propTypes2.default.object // eslint-disable-line react/forbid-prop-types
};

var defaultProps = {
  text: null,
  style: {}
};

var displayName = 'Divider';

/** Dividers group and separate content within lists and page layouts. */
var Divider = function Divider(_ref) {
  var text = _ref.text,
      style = _ref.style,
      custom = _objectWithoutProperties(_ref, ['text', 'style']);

  if (!text) {
    return _react2.default.createElement('hr', _extends({ style: _getStyles2.default.hr(style) }, custom));
  }

  return _react2.default.createElement(
    'h1',
    _extends({ style: _getStyles2.default.text(style) }, custom),
    text
  );
};

Divider.propTypes = propTypes;
Divider.defaultProps = defaultProps;
Divider.displayName = displayName;

exports.default = Divider;
module.exports = exports.default;