'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _colors = require('../settings/colors');

var _colors2 = _interopRequireDefault(_colors);

var _styles = require('../settings/styles');

var _styles2 = _interopRequireDefault(_styles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
  root: {
    borderRadius: '4px',
    backgroundColor: _colors2.default.white,
    overflow: 'hidden',
    width: '100%',
    maxHeight: '200px',
    boxShadow: _styles2.default.depthShadows[0]
  },
  header: {
    backgroundColor: _colors2.default.background
  },
  commands: {
    height: 'calc(100% - 40px)',
    overflowY: 'scroll',
    display: 'flex',
    flexWrap: 'wrap'
  },
  emoji: {
    height: '32px',
    boxSizing: 'border-box',
    padding: '4px',
    margin: '4px',
    fontSize: '14px',
    cursor: 'pointer',
    color: _colors2.default.secondaryText,
    display: 'flex',
    alignItems: 'center',
    justifyContent: 'space-between',
    borderRadius: '4px'
  },
  attributionLink: {
    color: _colors2.default.secondaryText,
    fontWeight: 'inherit',
    fontSize: '14px',
    textDecoration: 'none'
  },
  emojiIcon: {
    width: '24px',
    height: '24px',
    marginRight: '4px'
  }
};
module.exports = exports.default;