'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _styles = require('./styles');

var _styles2 = _interopRequireDefault(_styles);

var _combineStyles = require('../internal/combine-styles');

var _combineStyles2 = _interopRequireDefault(_combineStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function root(overrideStyle) {
  return (0, _combineStyles2.default)(_styles2.default.root, overrideStyle);
}

function categories(overrideStyle) {
  return (0, _combineStyles2.default)(_styles2.default.categories, overrideStyle);
}

function categoriesCategory(overrideStyle) {
  return (0, _combineStyles2.default)(_styles2.default.categories.category, overrideStyle);
}

function category(overrideStyle) {
  return (0, _combineStyles2.default)(_styles2.default.category, overrideStyle);
}

function categoryEmoji(overrideStyle) {
  return (0, _combineStyles2.default)(_styles2.default.category.emoji, overrideStyle);
}

function header(overrideStyle) {
  return (0, _combineStyles2.default)(_styles2.default.header, overrideStyle);
}

function modifiers(overrideStyle) {
  return (0, _combineStyles2.default)(_styles2.default.modifiers, overrideStyle);
}

function modifier(active, overrideStyle) {
  var style = _styles2.default.modifier;

  if (active) {
    style = (0, _combineStyles2.default)(style, _styles2.default.modifier.active);
  }

  return (0, _combineStyles2.default)(style, overrideStyle);
}

exports.default = {
  root: root,
  categories: categories,
  categoriesCategory: categoriesCategory,
  category: category,
  categoryEmoji: categoryEmoji,
  modifiers: modifiers,
  header: header,
  modifier: modifier
};
module.exports = exports.default;