'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _getStyles = require('./get-styles');

var _getStyles2 = _interopRequireDefault(_getStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var propTypes = {
  /** Body text */
  headerText: _propTypes2.default.node.isRequired,
  /** Header text */
  bodyText: _propTypes2.default.node.isRequired,
  /** A call to action button */
  button: _propTypes2.default.node,
  /** Path to background image */
  background: _propTypes2.default.string,
  /** Override the styles of the root element */
  style: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  /** Override the styles of the header text element */
  headingStyle: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  /** Override the styles of the body text element */
  bodyStyle: _propTypes2.default.object // eslint-disable-line react/forbid-prop-types
};

var defaultProps = {
  button: null,
  background: '',
  style: {},
  headingStyle: {},
  bodyStyle: {}
};

var displayName = 'EmptyState';

/** Pretty placeholder for empty content */
var EmptyState = function EmptyState(_ref) {
  var headerText = _ref.headerText,
      bodyText = _ref.bodyText,
      button = _ref.button,
      background = _ref.background,
      style = _ref.style,
      headingStyle = _ref.headingStyle,
      bodyStyle = _ref.bodyStyle,
      custom = _objectWithoutProperties(_ref, ['headerText', 'bodyText', 'button', 'background', 'style', 'headingStyle', 'bodyStyle']);

  return _react2.default.createElement(
    'section',
    _extends({ style: _getStyles2.default.root(background, style) }, custom),
    _react2.default.createElement(
      'h1',
      { style: _getStyles2.default.heading(headingStyle) },
      headerText
    ),
    _react2.default.createElement(
      'p',
      { style: _getStyles2.default.body(bodyStyle) },
      bodyText
    ),
    button
  );
};

EmptyState.propTypes = propTypes;
EmptyState.defaultProps = defaultProps;
EmptyState.displayName = displayName;

exports.default = EmptyState;
module.exports = exports.default;