'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _styles = require('./styles');

var _styles2 = _interopRequireDefault(_styles);

var _combineStyles = require('../internal/combine-styles');

var _combineStyles2 = _interopRequireDefault(_combineStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var root = function root(overrideStyle) {
  return (0, _combineStyles2.default)(_styles2.default.root, overrideStyle);
};

var itemContainer = function itemContainer(rowHeight, enableLightbox, overrideStyle) {
  var style = (0, _combineStyles2.default)(_styles2.default.itemContainer, { height: rowHeight });

  if (enableLightbox) {
    style = (0, _combineStyles2.default)(style, { cursor: 'pointer' });
  }

  return (0, _combineStyles2.default)(style, overrideStyle);
};

var item = function item(rowHeight, overrideStyle) {
  return (0, _combineStyles2.default)((0, _combineStyles2.default)(_styles2.default.item, { height: rowHeight }), overrideStyle);
};

var colorPlaceholder = function colorPlaceholder(color, originalWidth, originalHeight, rowHeight, overrideStyle) {
  var width = originalWidth * rowHeight / originalHeight;

  var style = (0, _combineStyles2.default)(_styles2.default.item, { backgroundColor: color, width: width, height: rowHeight });

  return (0, _combineStyles2.default)(style, overrideStyle);
};

exports.default = {
  root: root,
  itemContainer: itemContainer,
  item: item,
  colorPlaceholder: colorPlaceholder
};
module.exports = exports.default;