'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _styles = require('./styles');

var _styles2 = _interopRequireDefault(_styles);

var _combineStyles = require('../internal/combine-styles');

var _combineStyles2 = _interopRequireDefault(_combineStyles);

var _colors = require('../settings/colors');

var _colors2 = _interopRequireDefault(_colors);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var root = function root(disabled, overrideStyle) {
  var style = _styles2.default.root;

  if (disabled) {
    style = (0, _combineStyles2.default)(style, _styles2.default.disabled);
  }

  return (0, _combineStyles2.default)(style, overrideStyle);
};

var label = function label(overrideStyle) {
  return (0, _combineStyles2.default)(_styles2.default.label, overrideStyle);
};

var input = function input() {
  var errorMessage = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
  var overrideStyle = arguments[1];

  var style = _styles2.default.input;

  if (errorMessage) {
    style = (0, _combineStyles2.default)(style, { border: '1px solid ' + _colors2.default.error, color: _colors2.default.error });
  }

  return (0, _combineStyles2.default)(style, overrideStyle);
};

var textarea = function textarea() {
  var errorMessage = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
  var overrideStyle = arguments[1];

  var style = (0, _combineStyles2.default)(_styles2.default.input, _styles2.default.textarea);

  if (errorMessage) {
    style = (0, _combineStyles2.default)(style, { border: '1px solid ' + _colors2.default.error, color: _colors2.default.error });
  }

  return (0, _combineStyles2.default)(style, overrideStyle);
};

var error = function error(overrideStyle) {
  return (0, _combineStyles2.default)(_styles2.default.error, overrideStyle);
};

var inputRoot = function inputRoot() {
  var height = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 32;
  return (0, _combineStyles2.default)(_styles2.default.inputRoot, { height: height });
};

var placeholder = function placeholder(overrideStyle) {
  return (0, _combineStyles2.default)(_styles2.default.placeholder, overrideStyle);
};

exports.default = {
  root: root,
  label: label,
  input: input,
  error: error,
  textarea: textarea,
  inputRoot: inputRoot,
  placeholder: placeholder
};
module.exports = exports.default;