'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var minMax = function minMax(props, propName, componentName) {
  for (var _len = arguments.length, rest = Array(_len > 3 ? _len - 3 : 0), _key = 3; _key < _len; _key++) {
    rest[_key - 3] = arguments[_key];
  }

  var error = _propTypes2.default.number.apply(_propTypes2.default, [props, propName, componentName].concat(rest));

  if (error !== null) {
    return error;
  }

  if (props.min >= props.max) {
    // eslint-disable-line react/destructuring-assignment
    var errorMsg = propName === 'min' ? 'min should be less than max' : 'max should be greater than min';

    return new Error(errorMsg);
  }

  return null;
};

var valueInRange = function valueInRange(props, propName, componentName) {
  for (var _len2 = arguments.length, rest = Array(_len2 > 3 ? _len2 - 3 : 0), _key2 = 3; _key2 < _len2; _key2++) {
    rest[_key2 - 3] = arguments[_key2];
  }

  var error = _propTypes2.default.number.apply(_propTypes2.default, [props, propName, componentName].concat(rest));

  if (error !== null) {
    return error;
  }

  var value = props[propName]; // eslint-disable-line react/destructuring-assignment

  if (value < props.min || props.max < value) {
    // eslint-disable-line react/destructuring-assignment
    return new Error(propName + ' should be within the range specified by min and max');
  }

  return null;
};

exports.default = {
  minMax: minMax,
  valueInRange: valueInRange
};
module.exports = exports.default;