'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _colors = require('../settings/colors');

var _colors2 = _interopRequireDefault(_colors);

var _darken = require('../internal/darken');

var _darken2 = _interopRequireDefault(_darken);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
  root: {
    backgroundColor: _colors2.default.white,
    boxSizing: 'border-box',
    cursor: 'pointer',
    display: 'flex',
    alignItems: 'center',
    height: '52px',
    listStyle: 'none',
    paddingTop: '0',
    paddingRight: '8px',
    paddingLeft: '8px',
    paddingBottom: '0',
    position: 'relative',
    transition: 'background-color .3s ease-in-out',

    ':hover': {
      backgroundColor: (0, _darken2.default)(_colors2.default.white, 0.05)
    },
    ':active': {
      backgroundColor: (0, _darken2.default)(_colors2.default.white, 0.15)
    }
  },
  active: {
    backgroundColor: _colors2.default.theme,
    color: _colors2.default.white,

    ':hover': {
      backgroundColor: (0, _darken2.default)(_colors2.default.theme, 0.05)
    },
    ':active': {
      backgroundColor: (0, _darken2.default)(_colors2.default.theme, 0.15)
    }
  },
  icon: {
    position: 'absolute',
    top: '0',
    left: '0',
    width: '40px',
    height: '40px',
    padding: '8px',
    boxSizing: 'border-box',
    backgroundColor: 'rgba(21, 21, 21, .75)',
    borderRadius: '50%'
  },
  rightButton: {
    paddingRight: '52px'
  },
  button: {
    transition: 'transform .3s ease-in-out',
    width: '40px',
    height: '40px'
  },
  primaryText: {
    color: _colors2.default.primaryText,
    fontSize: '16px',
    margin: 0,
    lineHeight: '18px',
    userSelect: 'none',
    whiteSpace: 'nowrap',
    overflow: 'hidden',
    textOverflow: 'ellipsis',
    fontWeight: 'inherit'
  },
  secondaryText: {
    color: _colors2.default.secondaryText,
    fontSize: '14px',
    fontWeight: 'inherit',
    marginBottom: 0,
    marginTop: '2.4px',
    lineHeight: '16px',
    userSelect: 'none',
    whiteSpace: 'nowrap',
    overflow: 'hidden',
    textOverflow: 'ellipsis'
  },
  leftAvatar: {
    paddingLeft: '56px'
  },
  avatar: {
    position: 'relative',
    marginRight: '8px',
    width: '40px',
    height: '40px'
  },
  badge: {
    position: 'absolute',
    right: '-3px',
    top: '-3px'
  },
  container: {
    width: '100%'
  },
  text: {
    width: '100%',
    paddingRight: '8px',
    boxSizing: 'border-box'
  }
};
module.exports = exports.default;