'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _getStyles = require('./get-styles');

var _getStyles2 = _interopRequireDefault(_getStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var displayName = 'Loader';

var propTypes = {
  /** Override the styles of the root element */
  style: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  /** Override the styles of the dot element */
  dotStyle: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  /** Inverts the color */
  inverted: _propTypes2.default.bool,
  color: _propTypes2.default.string.isRequired
};

var defaultProps = {
  style: {},
  dotStyle: {},
  inverted: false
};

/** Animated loader */
var Loader = function Loader(_ref) {
  var inverted = _ref.inverted,
      style = _ref.style,
      dotStyle = _ref.dotStyle,
      color = _ref.color,
      custom = _objectWithoutProperties(_ref, ['inverted', 'style', 'dotStyle', 'color']);

  return _react2.default.createElement(
    'div',
    _extends({ style: _getStyles2.default.root(style) }, custom),
    _react2.default.createElement('span', { style: _getStyles2.default.dot(color, inverted, 0, dotStyle) }),
    _react2.default.createElement('span', { style: _getStyles2.default.dot(color, inverted, 1, dotStyle) }),
    _react2.default.createElement('span', { style: _getStyles2.default.dot(color, inverted, 2, dotStyle) })
  );
};

Loader.displayName = displayName;
Loader.propTypes = propTypes;
Loader.defaultProps = defaultProps;

exports.default = Loader;
module.exports = exports.default;