'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _styles = require('./styles');

var _styles2 = _interopRequireDefault(_styles);

var _combineStyles = require('../internal/combine-styles');

var _combineStyles2 = _interopRequireDefault(_combineStyles);

var _colors = require('../settings/colors');

var _colors2 = _interopRequireDefault(_colors);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var root = function root(overrideStyle) {
  return (0, _combineStyles2.default)(_styles2.default.root, overrideStyle);
};

var dot = function dot() {
  var color = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _colors2.default.theme;
  var inverted = arguments[1];
  var index = arguments[2];
  var overrideStyle = arguments[3];

  var style = (0, _combineStyles2.default)(_styles2.default.dot, { backgroundColor: color });

  if (index === 1) {
    style = (0, _combineStyles2.default)(style, { animationDelay: '.33s' });
  }

  if (index === 2) {
    style = (0, _combineStyles2.default)(style, { animationDelay: '.66s' });
  }

  if (inverted) {
    return (0, _combineStyles2.default)((0, _combineStyles2.default)(style, _styles2.default.inverted), overrideStyle);
  }

  return (0, _combineStyles2.default)(style, overrideStyle);
};

exports.default = {
  root: root,
  dot: dot
};
module.exports = exports.default;