'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _colors = require('../settings/colors');

var _colors2 = _interopRequireDefault(_colors);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var loaderAnimation = _radium2.default.keyframes({
  '0%': { opacity: 1 },
  '50%': {
    opacity: 0.25,
    transform: 'translateY(-10px)'
  },
  '100%': { opacity: 1 }
}, 'loader');

exports.default = {
  root: {
    display: 'flex',
    flexDirection: 'row',
    paddingTop: '10px'
  },
  dot: {
    backgroundColor: _colors2.default.theme,
    borderRadius: '50%',
    display: 'block',
    width: '15px',
    height: '15px',
    margin: '0 5px',
    transition: 'background .3s ease-in-out',
    animation: 'x 1s ease-in-out infinite',
    animationName: loaderAnimation,
    '&:nth-of-type(2)': {
      animationDelay: '.33s'
    },
    '&:last-of-type': {
      animationDelay: '.66s'
    }
  },
  inverted: {
    backgroundColor: _colors2.default.white
  }
};
module.exports = exports.default;