'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _isObject = require('lodash/isObject');

var _isObject2 = _interopRequireDefault(_isObject);

var _forEach = require('lodash/forEach');

var _forEach2 = _interopRequireDefault(_forEach);

var _mapValues = require('lodash/mapValues');

var _mapValues2 = _interopRequireDefault(_mapValues);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var propTypes = {
  /** Media query to listen for, must be an object of valid CSS Media queries */
  query: _propTypes2.default.objectOf(_propTypes2.default.string).isRequired,
  /**
   * Callback fired when the window resizes, is also fired on mount
   *
   * function(matches: object) => void
   */
  onChange: _propTypes2.default.func.isRequired
};

var displayName = 'Media';

/** CSS media query component, listens to matches for given queries */

var Media = function (_Component) {
  _inherits(Media, _Component);

  function Media() {
    _classCallCheck(this, Media);

    var _this = _possibleConstructorReturn(this, (Media.__proto__ || Object.getPrototypeOf(Media)).call(this));

    _this.updateMatches = function () {
      var onChange = _this.props.onChange;


      var matches = (0, _mapValues2.default)(_this.mediaQueryList, 'matches');

      onChange(matches);
    };

    _this.mediaQueryList = {};
    return _this;
  }

  _createClass(Media, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      if (!(0, _isObject2.default)(window)) {
        return false;
      }

      var query = this.props.query;


      (0, _forEach2.default)(query, function (value, key) {
        _this2.mediaQueryList[key] = window.matchMedia(value);
        _this2.mediaQueryList[key].addListener(_this2.updateMatches);
      });

      return this.updateMatches();
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      var _this3 = this;

      (0, _forEach2.default)(this.mediaQueryList, function (value, key) {
        _this3.mediaQueryList[key].removeListener(_this3.updateMatches);
      });
    }
  }, {
    key: 'render',
    value: function render() {
      // eslint-disable-line lodash/prefer-constant
      return null;
    }
  }]);

  return Media;
}(_react.Component);

Media.propTypes = propTypes;
Media.displayName = displayName;

exports.default = Media;
module.exports = exports.default;