'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _styles = require('./styles');

var _styles2 = _interopRequireDefault(_styles);

var _combineStyles = require('../internal/combine-styles');

var _combineStyles2 = _interopRequireDefault(_combineStyles);

var _colors = require('../settings/colors');

var _colors2 = _interopRequireDefault(_colors);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var root = function root() {
  var color = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _colors2.default.theme;
  var iconElement = arguments[1];
  var active = arguments[2];
  var rightButton = arguments[3];
  var overrideStyle = arguments[4];
  var activeStyle = arguments[5];

  var style = _styles2.default.root;

  if (iconElement) {
    style = (0, _combineStyles2.default)(style, { paddingLeft: '40px' });
  }

  if (active) {
    style = (0, _combineStyles2.default)(style, { color: color, fontWeight: 'bolder' });
  }

  if (rightButton) {
    style = (0, _combineStyles2.default)(style, { paddingRight: '56px' });
  }

  if (active) {
    return (0, _combineStyles2.default)(style, (0, _combineStyles2.default)(overrideStyle, activeStyle));
  }

  return (0, _combineStyles2.default)(style, overrideStyle);
};

var text = function text(overrideStyle) {
  return (0, _combineStyles2.default)(_styles2.default.text, overrideStyle);
};

var icon = function icon(overrideStyle) {
  return (0, _combineStyles2.default)(_styles2.default.icon, overrideStyle);
};

var rightButton = function rightButton(overrideStyle) {
  return (0, _combineStyles2.default)(_styles2.default.rightButton, overrideStyle);
};

exports.default = {
  root: root,
  text: text,
  icon: icon,
  rightButton: rightButton
};
module.exports = exports.default;