'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _colors = require('../settings/colors');

var _colors2 = _interopRequireDefault(_colors);

var _darken = require('../internal/darken');

var _darken2 = _interopRequireDefault(_darken);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styleSheet = {
  root: {
    minHeight: '40px',
    width: '100%',
    position: 'relative',
    paddingTop: '8px',
    paddingRight: '8px',
    paddingLeft: '8px',
    paddingBottom: '8px',
    boxSizing: 'border-box',
    cursor: 'pointer',
    color: _colors2.default.primaryText,
    transition: 'background-color .3s ease-in-out',
    backgroundColor: _colors2.default.white,
    ':hover': {
      backgroundColor: (0, _darken2.default)(_colors2.default.white, 0.05)
    },
    ':active': {
      backgroundColor: (0, _darken2.default)(_colors2.default.white, 0.15)
    }
  },
  text: {
    margin: 0,
    color: 'inherit',
    fontSize: '16px',
    lineHeight: '24px',
    overflow: 'hidden',
    textOverflow: 'ellipsis',
    fontWeight: 'inherit',
    whiteSpace: 'nowrap'
  },
  icon: {
    position: 'absolute',
    top: '8px',
    left: '8px',
    width: '24px',
    height: '24px'
  },
  rightButton: {
    position: 'absolute',
    top: '0',
    right: '8px',
    height: '40px',
    width: '40px'
  }
};

exports.default = styleSheet;
module.exports = exports.default;