'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _styles = require('./styles');

var _styles2 = _interopRequireDefault(_styles);

var _combineStyles = require('../internal/combine-styles');

var _combineStyles2 = _interopRequireDefault(_combineStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var root = function root(disabled) {
  var height = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '48px';
  var multiLine = arguments[2];
  var overrideStyle = arguments[3];

  var style = (0, _combineStyles2.default)(_styles2.default.root, { height: height });

  if (multiLine) {
    style = (0, _combineStyles2.default)(style, { alignItems: 'flex-end' });
  }

  if (disabled) {
    style = (0, _combineStyles2.default)(style, _styles2.default.disabled);
  }

  return (0, _combineStyles2.default)(style, overrideStyle);
};

var input = function input(overrideStyle) {
  return (0, _combineStyles2.default)(_styles2.default.input, overrideStyle);
};
var placeholder = function placeholder(overrideStyle) {
  return (0, _combineStyles2.default)(_styles2.default.placeholder, overrideStyle);
};

var textarea = function textarea(overrideStyle) {
  return (0, _combineStyles2.default)((0, _combineStyles2.default)(_styles2.default.input, _styles2.default.textarea), overrideStyle);
};

exports.default = {
  root: root,
  input: input,
  placeholder: placeholder,
  textarea: textarea
};
module.exports = exports.default;