'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _isEmpty = require('lodash/isEmpty');

var _isEmpty2 = _interopRequireDefault(_isEmpty);

var _getStyles = require('./get-styles');

var _getStyles2 = _interopRequireDefault(_getStyles);

var _messageHeader = require('../message-header');

var _messageHeader2 = _interopRequireDefault(_messageHeader);

var _messageTime = require('../message-time');

var _messageTime2 = _interopRequireDefault(_messageTime);

var _styles = require('./styles');

var _styles2 = _interopRequireDefault(_styles);

var _lightbox = require('../../lightbox');

var _lightbox2 = _interopRequireDefault(_lightbox);

var _combineStyles = require('../../internal/combine-styles');

var _combineStyles2 = _interopRequireDefault(_combineStyles);

var _imageLoader = require('../../image-loader');

var _imageLoader2 = _interopRequireDefault(_imageLoader);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var propTypes = {
  avatar: _propTypes2.default.string,
  body: _propTypes2.default.node.isRequired,
  createdAt: _propTypes2.default.string.isRequired,
  username: _propTypes2.default.node.isRequired,
  type: _propTypes2.default.oneOf(['text', 'image', 'sticker', 'giphy', 'video', 'audio']),
  style: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  messageHeaderStyle: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  messageBodyStyle: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  messageTimeStyle: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  fontSize: _propTypes2.default.oneOf(['small', 'medium', 'large']),
  myMessage: _propTypes2.default.bool,
  enableLightbox: _propTypes2.default.bool,
  compact: _propTypes2.default.bool,
  color: _propTypes2.default.string,
  collapsed: _propTypes2.default.bool,
  collapsedText: _propTypes2.default.node.isRequired,
  giphyDescription: _propTypes2.default.node.isRequired,
  badge: _propTypes2.default.node,
  imageLoaderProps: _propTypes2.default.object.isRequired, // eslint-disable-line react/forbid-prop-types
  iconMenu: _propTypes2.default.node
};

var defaultProps = {
  avatar: '',
  type: 'text',
  style: {},
  messageHeaderStyle: {},
  messageBodyStyle: {},
  messageTimeStyle: {},
  fontSize: 'small',
  myMessage: false,
  compact: false,
  enableLightbox: false,
  color: '',
  collapsed: false,
  badge: null,
  iconMenu: null
};

var GiphyMessage = function (_Component) {
  _inherits(GiphyMessage, _Component);

  function GiphyMessage() {
    _classCallCheck(this, GiphyMessage);

    var _this = _possibleConstructorReturn(this, (GiphyMessage.__proto__ || Object.getPrototypeOf(GiphyMessage)).call(this));

    _this.toggleLightbox = function () {
      var enableLightbox = _this.props.enableLightbox;
      var lightbox = _this.state.lightbox;


      if (!enableLightbox) {
        return false;
      }

      return _this.setState({
        lightbox: !lightbox
      });
    };

    _this.state = {
      lightbox: false
    };
    return _this;
  }

  _createClass(GiphyMessage, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          color = _props.color,
          myMessage = _props.myMessage,
          avatar = _props.avatar,
          compact = _props.compact,
          style = _props.style,
          fontSize = _props.fontSize,
          messageHeaderStyle = _props.messageHeaderStyle,
          body = _props.body,
          createdAt = _props.createdAt,
          username = _props.username,
          type = _props.type,
          messageBodyStyle = _props.messageBodyStyle,
          messageTimeStyle = _props.messageTimeStyle,
          enableLightbox = _props.enableLightbox,
          collapsed = _props.collapsed,
          collapsedText = _props.collapsedText,
          giphyDescription = _props.giphyDescription,
          badge = _props.badge,
          imageLoaderProps = _props.imageLoaderProps,
          iconMenu = _props.iconMenu;
      var lightbox = this.state.lightbox;


      var onClick = null;
      var headerStyle = (0, _combineStyles2.default)(messageHeaderStyle, { marginBottom: '9px' });

      if (enableLightbox) {
        onClick = this.toggleLightbox;
      }

      if (collapsed) {
        headerStyle = (0, _combineStyles2.default)(headerStyle, { marginBottom: '5px' });
      }

      var imgProps = {
        onClick: onClick,
        style: _getStyles2.default.giphy(enableLightbox)
      };

      return _react2.default.createElement(
        'div',
        { style: _getStyles2.default.root(color, myMessage, avatar, compact, collapsed, iconMenu, style) },
        _react2.default.createElement(_messageHeader2.default, {
          avatar: avatar,
          compact: compact,
          myMessage: myMessage,
          fontSize: fontSize,
          headerStyle: headerStyle,
          username: username,
          badge: badge,
          iconMenu: !(0, _isEmpty2.default)(iconMenu)
        }),
        _react2.default.createElement(
          'p',
          { style: _getStyles2.default.body(myMessage, fontSize, collapsed, messageBodyStyle) },
          !collapsed && giphyDescription ? _react2.default.createElement(
            'span',
            { style: _styles2.default.giphyDescription },
            giphyDescription
          ) : null,
          !collapsed ? _react2.default.createElement(_imageLoader2.default, _extends({
            src: body,
            alt: 'user-upload',
            imgProps: imgProps
          }, imageLoaderProps)) : _react2.default.createElement(
            'span',
            null,
            collapsedText
          ),
          _react2.default.createElement(_messageTime2.default, {
            myMessage: myMessage,
            type: type,
            style: messageTimeStyle,
            createdAt: createdAt,
            collapsed: collapsed,
            fontSize: fontSize
          })
        ),
        iconMenu ? _react2.default.createElement(
          'div',
          { style: _styles2.default.iconMenu },
          iconMenu
        ) : null,
        enableLightbox ? _react2.default.createElement(_lightbox2.default, {
          open: lightbox,
          image: body,
          title: username,
          hideLightbox: this.toggleLightbox
        }) : null
      );
    }
  }]);

  return GiphyMessage;
}(_react.Component);

GiphyMessage.propTypes = propTypes;
GiphyMessage.defaultProps = defaultProps;

exports.default = GiphyMessage;
module.exports = exports.default;