'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _colors = require('../../settings/colors');

var _colors2 = _interopRequireDefault(_colors);

var _combineStyles = require('../../internal/combine-styles');

var _combineStyles2 = _interopRequireDefault(_combineStyles);

var _styles = require('./styles');

var _styles2 = _interopRequireDefault(_styles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var header = function header() {
  var color = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _colors2.default.theme;
  var myMessage = arguments[1];
  var avatar = arguments[2];
  var compact = arguments[3];
  var iconMenu = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : false;
  var overrideStyle = arguments[5];

  var style = _styles2.default.message;

  if (myMessage) {
    style = (0, _combineStyles2.default)((0, _combineStyles2.default)(_styles2.default.message, _styles2.default.myMessage), { backgroundColor: color, borderRightColor: color, alignSelf: 'flex-end' });
  }

  if (avatar) {
    style = (0, _combineStyles2.default)(style, _styles2.default.avatar);
  }

  if (myMessage && avatar) {
    style = (0, _combineStyles2.default)(style, _styles2.default.myAvatar);
  }

  if (compact) {
    style = (0, _combineStyles2.default)(style, _styles2.default.compact);
  }

  if (iconMenu) {
    style = (0, _combineStyles2.default)(style, { padding: '13px 48px 13px 13px' });
  }

  return (0, _combineStyles2.default)(style, overrideStyle);
};

var body = function body(myMessage, avatar, compact, overrideStyle) {
  var style = _styles2.default.body;

  if (myMessage) {
    style = (0, _combineStyles2.default)(style, { marginLeft: '0', marginRight: '16px', alignSelf: 'flex-end' });
  }

  if (avatar) {
    style = (0, _combineStyles2.default)(style, _styles2.default.avatar);
  }

  if (myMessage && avatar) {
    style = (0, _combineStyles2.default)(style, _styles2.default.myAvatar);
  }

  if (compact) {
    style = (0, _combineStyles2.default)(style, { alignSelf: 'flex-start', marginLeft: 0, marginRight: 0 });
  }

  return (0, _combineStyles2.default)(style, overrideStyle);
};

exports.default = {
  header: header,
  body: body
};
module.exports = exports.default;