'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _styles = require('./styles');

var _styles2 = _interopRequireDefault(_styles);

var _combineStyles = require('../internal/combine-styles');

var _combineStyles2 = _interopRequireDefault(_combineStyles);

var _colors = require('../settings/colors');

var _colors2 = _interopRequireDefault(_colors);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var root = function root(overrideStyle) {
  return (0, _combineStyles2.default)(_styles2.default.root, overrideStyle);
};

var content = function content(overrideStyle) {
  return (0, _combineStyles2.default)(_styles2.default.content, overrideStyle);
};

var footer = function footer() {
  var color = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _colors2.default.theme;
  var overrideStyle = arguments[1];

  var style = (0, _combineStyles2.default)(_styles2.default.footer, { backgroundColor: color });

  return (0, _combineStyles2.default)(style, overrideStyle);
};

var header = function header(overrideStyle) {
  return (0, _combineStyles2.default)(_styles2.default.header, overrideStyle);
};

exports.default = {
  root: root,
  header: header,
  content: content,
  footer: footer
};
module.exports = exports.default;