'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _styles = require('./styles');

var _styles2 = _interopRequireDefault(_styles);

var _combineStyles = require('../internal/combine-styles');

var _combineStyles2 = _interopRequireDefault(_combineStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var root = function root(overrideStyle) {
  return (0, _combineStyles2.default)(_styles2.default.root, overrideStyle);
};
var header = function header(overrideStyle) {
  return (0, _combineStyles2.default)(_styles2.default.header, overrideStyle);
};
var nav = function nav() {
  var position = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'top';
  var overrideStyle = arguments[1];

  var style = _styles2.default.nav;

  if (position === 'top') {
    style = (0, _combineStyles2.default)(style, { marginBottom: '10px', marginTop: 0 });
  }

  if (position === 'bottom') {
    style = (0, _combineStyles2.default)(style, { marginBottom: 0, marginTop: '10px' });
  }

  return (0, _combineStyles2.default)(style, overrideStyle);
};
var navButton = function navButton(overrideStyle) {
  return (0, _combineStyles2.default)(_styles2.default.navButton, overrideStyle);
};
var iconButton = function iconButton(overrideStyle) {
  return (0, _combineStyles2.default)(navButton(_styles2.default.iconButton), overrideStyle);
};

exports.default = {
  root: root,
  header: header,
  nav: nav,
  navButton: navButton,
  iconButton: iconButton
};
module.exports = exports.default;