'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _isEqual = require('lodash/isEqual');

var _isEqual2 = _interopRequireDefault(_isEqual);

var _size = require('lodash/size');

var _size2 = _interopRequireDefault(_size);

var _map = require('lodash/map');

var _map2 = _interopRequireDefault(_map);

var _getPager = require('../internal/get-pager');

var _getPager2 = _interopRequireDefault(_getPager);

var _getStyles = require('./get-styles');

var _getStyles2 = _interopRequireDefault(_getStyles);

var _button = require('../button');

var _button2 = _interopRequireDefault(_button);

var _iconChevronLeft = require('../icons/icon-chevron-left');

var _iconChevronLeft2 = _interopRequireDefault(_iconChevronLeft);

var _iconChevronRight = require('../icons/icon-chevron-right');

var _iconChevronRight2 = _interopRequireDefault(_iconChevronRight);

var _iconFirst = require('../icons/icon-first');

var _iconFirst2 = _interopRequireDefault(_iconFirst);

var _iconLast = require('../icons/icon-last');

var _iconLast2 = _interopRequireDefault(_iconLast);

var _colors = require('../settings/colors');

var _colors2 = _interopRequireDefault(_colors);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/** Navigate through large sets of data */
var Pagination = function (_Component) {
  _inherits(Pagination, _Component);

  function Pagination() {
    _classCallCheck(this, Pagination);

    var _this = _possibleConstructorReturn(this, (Pagination.__proto__ || Object.getPrototypeOf(Pagination)).call(this));

    _this.setPage = function (event, page, list, pageSize) {
      var onChange = _this.props.onChange;


      var newPager = (0, _getPager2.default)(list, page, pageSize);

      var items = list.slice(newPager.startIndex, newPager.endIndex + 1);

      _this.setState({ pager: newPager });

      onChange(event, {
        items: items,
        totalItems: newPager.totalItems,
        totalPages: newPager.totalPages,
        currentPage: newPager.currentPage
      });
    };

    _this.state = {
      pager: {}
    };
    return _this;
  }

  _createClass(Pagination, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _props = this.props,
          initialPage = _props.initialPage,
          list = _props.list,
          pageSize = _props.pageSize;

      this.setPage({}, initialPage, list, pageSize);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var initialPage = nextProps.initialPage,
          list = nextProps.list,
          pageSize = nextProps.pageSize,
          jumpToPage = nextProps.jumpToPage;


      if (!(0, _isEqual2.default)(list, this.props.list) || !(0, _isEqual2.default)(pageSize, this.props.pageSize)) {
        // eslint-disable-line react/destructuring-assignment
        this.setPage({}, initialPage, list, pageSize);
      }

      if (!(0, _isEqual2.default)(jumpToPage, this.props.jumpToPage)) {
        // eslint-disable-line react/destructuring-assignment
        this.setPage({}, jumpToPage, list, pageSize);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props2 = this.props,
          list = _props2.list,
          pageSize = _props2.pageSize,
          children = _props2.children,
          style = _props2.style,
          navStyle = _props2.navStyle,
          navButtonStyle = _props2.navButtonStyle,
          iconButtonStyle = _props2.iconButtonStyle,
          position = _props2.position;
      var pager = this.state.pager;
      var currentPage = pager.currentPage,
          pages = pager.pages,
          totalPages = pager.totalPages;


      var nav = _react2.default.createElement(
        'nav',
        { style: _getStyles2.default.nav(position, navStyle) },
        _react2.default.createElement(
          _button2.default,
          {
            disabled: currentPage === 1,
            onClick: function onClick(event) {
              return _this2.setPage(event, 1, list, pageSize);
            },
            style: _getStyles2.default.iconButton(iconButtonStyle)
          },
          _react2.default.createElement(_iconFirst2.default, { color: _colors2.default.white })
        ),
        _react2.default.createElement(
          _button2.default,
          {
            onClick: function onClick(event) {
              return _this2.setPage(event, currentPage - 1, list, pageSize);
            },
            disabled: currentPage === 1,
            style: _getStyles2.default.iconButton(iconButtonStyle)
          },
          _react2.default.createElement(_iconChevronLeft2.default, { color: _colors2.default.white })
        ),
        (0, _map2.default)(pages, function (page, index) {
          return _react2.default.createElement(
            _button2.default,
            {
              key: index,
              onClick: function onClick(event) {
                return _this2.setPage(event, page, list, pageSize);
              },
              style: _getStyles2.default.navButton(navButtonStyle),
              disabled: currentPage === page,
              inverted: true
            },
            page
          );
        }),
        _react2.default.createElement(
          _button2.default,
          {
            disabled: currentPage === totalPages,
            onClick: function onClick(event) {
              return _this2.setPage(event, currentPage + 1, list, pageSize);
            },
            style: _getStyles2.default.iconButton(iconButtonStyle)
          },
          _react2.default.createElement(_iconChevronRight2.default, { color: _colors2.default.white })
        ),
        _react2.default.createElement(
          _button2.default,
          {
            disabled: currentPage === totalPages,
            onClick: function onClick(event) {
              return _this2.setPage(event, totalPages, list, pageSize);
            },
            style: _getStyles2.default.iconButton(iconButtonStyle)
          },
          _react2.default.createElement(_iconLast2.default, { color: _colors2.default.white })
        )
      );

      return _react2.default.createElement(
        'section',
        { style: _getStyles2.default.root(style) },
        position === 'top' && (0, _size2.default)(list) > pageSize ? nav : null,
        children,
        position === 'bottom' && (0, _size2.default)(list) > pageSize ? nav : null
      );
    }
  }]);

  return Pagination;
}(_react.Component);

Pagination.propTypes = {
  /** The list to navigate through */
  list: _propTypes2.default.arrayOf(Object).isRequired,
  /**
   * Callback fired when the navigation changes
   *
   * function(event: object, pager: object) => void
   */
  onChange: _propTypes2.default.func.isRequired,
  /** Initial active page */
  initialPage: _propTypes2.default.number,
  /** The page's size */
  pageSize: _propTypes2.default.number,
  /** The paginated list */
  children: _propTypes2.default.node.isRequired,
  /** Override the styles of the root element */
  style: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  /** Override the styles of the nav element */
  navStyle: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  /** Override the styles of the nav button elements */
  navButtonStyle: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  /** Override the styles of the icon button elements */
  iconButtonStyle: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  /** The nav's position relative to the children. One of the following: ["top", "bottom"] */
  position: _propTypes2.default.oneOf(['top', 'bottom']),
  /** Jump to a certain page in the list */
  jumpToPage: _propTypes2.default.number
};

Pagination.defaultProps = {
  initialPage: 1,
  pageSize: 10,
  style: {},
  navStyle: {},
  navButtonStyle: {},
  iconButtonStyle: {},
  position: 'top',
  jumpToPage: 1
};

Pagination.displayName = 'Pagination';

exports.default = Pagination;
module.exports = exports.default;