'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _getStyles = require('./get-styles');

var _getStyles2 = _interopRequireDefault(_getStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

/** A Paper element is a basic container that can give depth to the page. */
var Paper = function Paper(_ref) {
  var children = _ref.children,
      depth = _ref.depth,
      style = _ref.style,
      custom = _objectWithoutProperties(_ref, ['children', 'depth', 'style']);

  return _react2.default.createElement(
    'section',
    _extends({ style: _getStyles2.default.root(depth, style) }, custom),
    children
  );
};

Paper.displayName = 'Paper';

Paper.propTypes = {
  /** The Paper's children */
  children: _propTypes2.default.node.isRequired,
  /** The Paper's shadow depth. One of the following: [1, 2, 3, 4, 5] */
  depth: _propTypes2.default.oneOf([1, 2, 3, 4, 5]),
  /** Override the style of the root element */
  style: _propTypes2.default.object // eslint-disable-line react/forbid-prop-types
};

Paper.defaultProps = {
  depth: 1,
  style: {}
};

exports.default = (0, _radium2.default)(Paper);
module.exports = exports.default;