'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _avatar = require('../avatar');

var _avatar2 = _interopRequireDefault(_avatar);

var _styles = require('./styles');

var _styles2 = _interopRequireDefault(_styles);

var _combineStyles = require('../internal/combine-styles');

var _combineStyles2 = _interopRequireDefault(_combineStyles);

var _getStyles = require('./get-styles');

var _getStyles2 = _interopRequireDefault(_getStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var displayName = 'ProfileCard';

var propTypes = {
  /** Path to the user's avatar */
  avatar: _propTypes2.default.string,
  /** The user's username */
  username: _propTypes2.default.node.isRequired,
  /** Override the styles of the root element */
  style: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  /** Override the styles of the username element */
  usernameStyle: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  color: _propTypes2.default.string.isRequired
};

var defaultProps = {
  avatar: '',
  style: {},
  usernameStyle: {}
};

/** Card containing a user's profile data */
var ProfileCard = function ProfileCard(_ref) {
  var username = _ref.username,
      avatar = _ref.avatar,
      style = _ref.style,
      usernameStyle = _ref.usernameStyle,
      color = _ref.color,
      custom = _objectWithoutProperties(_ref, ['username', 'avatar', 'style', 'usernameStyle', 'color']);

  return _react2.default.createElement(
    'section',
    _extends({ style: _getStyles2.default.root(color, avatar, style) }, custom),
    avatar ? _react2.default.createElement(_avatar2.default, { image: avatar, style: _getStyles2.default.avatar() }) : null,
    _react2.default.createElement(
      'h1',
      { style: (0, _combineStyles2.default)(_styles2.default.username, usernameStyle) },
      username
    )
  );
};

ProfileCard.displayName = displayName;
ProfileCard.propTypes = propTypes;
ProfileCard.defaultProps = defaultProps;

exports.default = ProfileCard;
module.exports = exports.default;