'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _getStyles = require('./get-styles');

var _getStyles2 = _interopRequireDefault(_getStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var propTypes = {
  /** The RadioButtonGroup's value */
  value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]).isRequired,
  /**
   * Callback fired when RadioButtonGroup's value changes
   *
   * function(event: object) => void
   */
  onChange: _propTypes2.default.func.isRequired,
  /** The RadioButtonGroup's content (RadioButton), each child must have a value prop */
  children: _propTypes2.default.node.isRequired,
  /** The RadioButtonGroup's label */
  label: _propTypes2.default.node.isRequired,
  /** Override the styles of the label element */
  labelStyle: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  /** Override the styles of the root element */
  style: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  /** Override the styles of the button container */
  buttonStyle: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  /** Display an error message */
  error: _propTypes2.default.node,
  /** Override the styles of the error element */
  errorStyle: _propTypes2.default.object // eslint-disable-line react/forbid-prop-types
};

var defaultProps = {
  labelStyle: {},
  style: {},
  error: null,
  errorStyle: {},
  buttonStyle: {}
};

var displayName = 'RadioButtonGroup';

var RadioButtonGroup = function RadioButtonGroup(_ref) {
  var value = _ref.value,
      onChange = _ref.onChange,
      children = _ref.children,
      buttonStyle = _ref.buttonStyle,
      label = _ref.label,
      labelStyle = _ref.labelStyle,
      style = _ref.style,
      error = _ref.error,
      errorStyle = _ref.errorStyle,
      custom = _objectWithoutProperties(_ref, ['value', 'onChange', 'children', 'buttonStyle', 'label', 'labelStyle', 'style', 'error', 'errorStyle']);

  var childrenWithProps = _react2.default.Children.map(children, function (child) {
    return _react2.default.cloneElement(child, {
      checked: child.props.value === value,
      onChange: onChange
    });
  });

  return _react2.default.createElement(
    'section',
    _extends({}, custom, { style: style }),
    _react2.default.createElement(
      'span',
      { style: _getStyles2.default.label(labelStyle) },
      label
    ),
    _react2.default.createElement(
      'section',
      { style: _getStyles2.default.buttons(buttonStyle) },
      childrenWithProps
    ),
    error ? _react2.default.createElement(
      'span',
      { style: _getStyles2.default.error(errorStyle) },
      error
    ) : null
  );
};

RadioButtonGroup.propTypes = propTypes;
RadioButtonGroup.defaultProps = defaultProps;
RadioButtonGroup.displayName = displayName;

exports.default = (0, _radium2.default)(RadioButtonGroup);
module.exports = exports.default;