'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _colors = require('../settings/colors');

var _colors2 = _interopRequireDefault(_colors);

var _darken = require('../internal/darken');

var _darken2 = _interopRequireDefault(_darken);

var _styles = require('../settings/styles');

var _styles2 = _interopRequireDefault(_styles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
  header: {
    minHeight: '32px',
    minWidth: '100%',
    position: 'relative',
    paddingTop: '8px',
    paddingRight: '40px',
    paddingLeft: '8px',
    paddingBottom: '8px',
    boxSizing: 'border-box',
    cursor: 'pointer',
    color: _colors2.default.white,
    backgroundColor: _colors2.default.theme,
    borderRadius: '4px',
    fontSize: '16px',
    lineHeight: '16px',
    transition: 'background .3s ease-in-out',
    boxShadow: _styles2.default.depthShadows[0],

    ':hover': {
      backgroundColor: (0, _darken2.default)(_colors2.default.theme, 0.05)
    },
    ':active': {
      backgroundColor: (0, _darken2.default)(_colors2.default.theme, 0.15)
    }
  },
  icon: {
    position: 'absolute',
    top: '50%',
    transform: 'translateY(-50%)',
    right: '8px',
    width: '24px',
    height: '24px',
    transition: 'transform .3s ease-in-out'
  },
  clickAway: {
    pointerEvents: 'all',
    position: 'fixed',
    width: '100vw',
    height: '100vh',
    top: 0,
    left: 0,
    zIndex: 1,
    opacity: 0
  },
  label: {
    fontSize: '16px',
    color: _colors2.default.secondaryText,
    fontWeight: 'bolder',
    padding: '0 0 8px',
    display: 'inline-block'
  },
  error: {
    display: 'block',
    paddingTop: '8px',
    paddingLeft: '8px',
    color: _colors2.default.error,
    fontSize: '14px'
  }
};
module.exports = exports.default;