'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _colors = require('../settings/colors');

var _colors2 = _interopRequireDefault(_colors);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
  root: {
    width: '100%',
    maxWidth: '250px'
  },
  sliderRoot: {
    height: '16px',
    width: '100%',
    position: 'relative'
  },
  slider: {
    position: 'absolute',
    top: '7px',
    left: '0px',
    width: '100%',
    height: '2px'
  },
  filled: {
    backgroundColor: _colors2.default.theme,
    height: '100%',
    width: '0%',
    position: 'absolute',
    left: 0,
    top: 0
  },
  remaining: {
    backgroundColor: _colors2.default.grey,
    height: '100%',
    width: '100%',
    position: 'absolute',
    right: 0,
    top: 0
  },
  button: {
    position: 'absolute',
    width: '12px',
    height: '12px',
    borderRadius: '50%',
    border: '2px solid ' + _colors2.default.grey,
    top: '1px',
    left: '0%',
    backgroundColor: _colors2.default.white,
    transform: 'translate(-50%, -50%)',
    transition: 'border .1s ease-in-out, background-color .1s ease-in-out',
    cursor: 'pointer'
  },
  input: {
    position: 'absolute',
    margin: 0,
    width: '100%',
    height: '100%',
    opacity: 0,
    cursor: 'pointer'
  },
  label: {
    fontSize: '16px',
    color: _colors2.default.secondaryText,
    fontWeight: 'bolder',
    marginBottom: '8px',
    display: 'inline-block'
  },
  error: {
    display: 'block',
    paddingTop: '8px',
    paddingLeft: '8px',
    color: _colors2.default.error,
    fontSize: '14px'
  },
  disabled: {
    opacity: '0.5'
  }
};
module.exports = exports.default;