'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styles = require('./styles');

var _styles2 = _interopRequireDefault(_styles);

var _getStyles = require('./get-styles');

var _getStyles2 = _interopRequireDefault(_getStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var propTypes = {
  /** The Switch's active state */
  active: _propTypes2.default.bool,
  /**
   * Callback fired when Switch's value changes
   *
   * function(event: object, value: string || number) => void
   */
  toggleSwitch: _propTypes2.default.func.isRequired,
  /** The Switch's label */
  label: _propTypes2.default.node.isRequired,
  /** Override the styles of the root element */
  style: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  /** Override the styles of the track element */
  trackStyle: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  /** Override the styles of the knob element */
  knobStyle: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  /** Override the styles of the label element */
  labelStyle: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  color: _propTypes2.default.string.isRequired
};

var defaultProps = {
  active: false,
  style: {},
  trackStyle: {},
  knobStyle: {},
  labelStyle: {}
};

var displayName = 'Switch';

var Switch = function Switch(_ref) {
  var active = _ref.active,
      label = _ref.label,
      toggleSwitch = _ref.toggleSwitch,
      style = _ref.style,
      trackStyle = _ref.trackStyle,
      knobStyle = _ref.knobStyle,
      labelStyle = _ref.labelStyle,
      color = _ref.color,
      custom = _objectWithoutProperties(_ref, ['active', 'label', 'toggleSwitch', 'style', 'trackStyle', 'knobStyle', 'labelStyle', 'color']);

  return _react2.default.createElement(
    'section',
    _extends({ style: style }, custom),
    _react2.default.createElement(
      'span',
      { style: _getStyles2.default.label(labelStyle) },
      label
    ),
    _react2.default.createElement(
      'section',
      { style: _styles2.default.wrapper, onClick: toggleSwitch },
      _react2.default.createElement('div', { style: _getStyles2.default.track(color, active, trackStyle) }),
      _react2.default.createElement('div', { style: _getStyles2.default.knob(color, active, knobStyle) })
    )
  );
};

Switch.propTypes = propTypes;
Switch.defaultProps = defaultProps;
Switch.displayName = displayName;

exports.default = Switch;
module.exports = exports.default;