'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _styles = require('./styles');

var _styles2 = _interopRequireDefault(_styles);

var _colors = require('../settings/colors');

var _colors2 = _interopRequireDefault(_colors);

var _combineStyles = require('../internal/combine-styles');

var _combineStyles2 = _interopRequireDefault(_combineStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var root = function root() {
  var color = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _colors2.default.theme;
  var selected = arguments[1];
  var overrideStyle = arguments[2];
  var activeStyle = arguments[3];

  var style = _styles2.default.root;

  if (selected) {
    return (0, _combineStyles2.default)((0, _combineStyles2.default)(style, { opacity: 1, borderBottom: '2px solid ' + color }), activeStyle);
  }

  return (0, _combineStyles2.default)(style, overrideStyle);
};

var label = function label(selected, overrideStyle, activeStyle) {
  var style = _styles2.default.label;

  if (selected) {
    return (0, _combineStyles2.default)(style, activeStyle);
  }

  return (0, _combineStyles2.default)(style, overrideStyle);
};

var icon = function icon(selected, overrideStyle) {
  return (0, _combineStyles2.default)(_styles2.default.icon, overrideStyle);
};

var badge = function badge(overrideStyle) {
  return (0, _combineStyles2.default)(_styles2.default.badge, overrideStyle);
};

exports.default = {
  root: root,
  label: label,
  icon: icon,
  badge: badge
};
module.exports = exports.default;