'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _compose = require('recompose/compose');

var _compose2 = _interopRequireDefault(_compose);

var _getStyles = require('./get-styles');

var _getStyles2 = _interopRequireDefault(_getStyles);

var _themeable = require('../themeable');

var _themeable2 = _interopRequireDefault(_themeable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var propTypes = {
  /** The Tab's icon */
  icon: _propTypes2.default.node,
  /** The Tab's label */
  label: _propTypes2.default.node.isRequired,
  /** Tab selected */
  selected: _propTypes2.default.bool,
  /**
   * Callback fired when Tab is clicked
   *
   * function(event: object, value: string || number) => void
   */
  onClick: _propTypes2.default.func.isRequired,
  /** Override the styles of an inactive root element */
  style: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  /** Override the styles of an inactive label element */
  labelStyle: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  /** Override the styles of the icon element */
  iconStyle: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  /** Badge for the tab */
  badge: _propTypes2.default.node,
  /** Override the styles of the badge element */
  badgeStyle: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  /** Overide the styles of an active root element. */
  activeStyle: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  /** Overide the styles of an active label element. */
  activeLabelStyle: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  color: _propTypes2.default.string.isRequired
};

var defaultProps = {
  icon: null,
  selected: false,
  style: {},
  labelStyle: {},
  iconStyle: {},
  badge: null,
  badgeStyle: {},
  activeStyle: {},
  activeLabelStyle: {}
};

var displayName = 'Tab';

var Tab = function Tab(_ref) {
  var onClick = _ref.onClick,
      icon = _ref.icon,
      label = _ref.label,
      selected = _ref.selected,
      style = _ref.style,
      iconStyle = _ref.iconStyle,
      labelStyle = _ref.labelStyle,
      badge = _ref.badge,
      badgeStyle = _ref.badgeStyle,
      activeStyle = _ref.activeStyle,
      activeLabelStyle = _ref.activeLabelStyle,
      color = _ref.color,
      custom = _objectWithoutProperties(_ref, ['onClick', 'icon', 'label', 'selected', 'style', 'iconStyle', 'labelStyle', 'badge', 'badgeStyle', 'activeStyle', 'activeLabelStyle', 'color']);

  return _react2.default.createElement(
    'section',
    _extends({
      style: _getStyles2.default.root(color, selected, style, activeStyle),
      onClick: onClick
    }, custom),
    icon ? _react2.default.createElement(
      'div',
      { style: _getStyles2.default.icon(selected, iconStyle) },
      icon
    ) : null,
    _react2.default.createElement(
      'span',
      { style: _getStyles2.default.label(selected, labelStyle, activeLabelStyle) },
      label
    ),
    badge ? _react2.default.createElement(
      'div',
      { style: _getStyles2.default.badge(badgeStyle) },
      badge
    ) : null
  );
};

Tab.propTypes = propTypes;
Tab.defaultProps = defaultProps;
Tab.displayName = displayName;

var enhance = (0, _compose2.default)((0, _themeable2.default)(), _radium2.default);

exports.default = enhance(Tab);
module.exports = exports.default;