'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _noop = require('lodash/noop');

var _noop2 = _interopRequireDefault(_noop);

var _isNumber = require('lodash/isNumber');

var _isNumber2 = _interopRequireDefault(_isNumber);

var _map = require('lodash/map');

var _map2 = _interopRequireDefault(_map);

var _getStyles = require('./get-styles');

var _getStyles2 = _interopRequireDefault(_getStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Tabs = function (_Component) {
  _inherits(Tabs, _Component);

  function Tabs(props) {
    _classCallCheck(this, Tabs);

    var _this = _possibleConstructorReturn(this, (Tabs.__proto__ || Object.getPrototypeOf(Tabs)).call(this, props));

    _this.state = {
      value: _this.getInitialSelectedTab()
    };

    _this.toggleTab = _this.toggleTab.bind(_this);
    return _this;
  }

  _createClass(Tabs, [{
    key: 'getInitialSelectedTab',
    value: function getInitialSelectedTab() {
      var _props = this.props,
          initialSelectedIndex = _props.initialSelectedIndex,
          children = _props.children;


      if (initialSelectedIndex > children.length - 1) {
        return 0;
      }

      return initialSelectedIndex;
    }
  }, {
    key: 'isSelectedTab',
    value: function isSelectedTab(index) {
      var selectedIndex = this.props.selectedIndex;
      var value = this.state.value;


      if ((0, _isNumber2.default)(selectedIndex)) {
        return index === selectedIndex;
      }

      return index === value;
    }
  }, {
    key: 'toggleTab',
    value: function toggleTab(event, value) {
      var onTabChange = this.props.onTabChange;


      this.setState({
        value: value
      });

      onTabChange(event, value);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props2 = this.props,
          children = _props2.children,
          style = _props2.style,
          tabContainerStyle = _props2.tabContainerStyle,
          contentContainerStyle = _props2.contentContainerStyle,
          contentStyle = _props2.contentStyle,
          initialSelectedIndex = _props2.initialSelectedIndex,
          onTabChange = _props2.onTabChange,
          selectedIndex = _props2.selectedIndex,
          custom = _objectWithoutProperties(_props2, ['children', 'style', 'tabContainerStyle', 'contentContainerStyle', 'contentStyle', 'initialSelectedIndex', 'onTabChange', 'selectedIndex']);

      var tabContent = [];

      var tabs = (0, _map2.default)(children, function (tab, index) {
        tabContent.push((0, _react.createElement)('div', {
          key: index,
          style: _getStyles2.default.tabContent(_this2.isSelectedTab(index), contentStyle)
        }, tab.props.children));

        return (0, _react.cloneElement)(tab, {
          key: index,
          selected: _this2.isSelectedTab(index),
          onClick: (0, _isNumber2.default)(selectedIndex) ? function (event) {
            return onTabChange(event, index);
          } : function (event) {
            return _this2.toggleTab(event, index);
          }
        });
      });

      return _react2.default.createElement(
        'section',
        _extends({ style: style }, custom),
        _react2.default.createElement(
          'section',
          { style: _getStyles2.default.tabContainer(tabContainerStyle) },
          tabs
        ),
        _react2.default.createElement(
          'section',
          { style: contentContainerStyle },
          tabContent
        )
      );
    }
  }]);

  return Tabs;
}(_react.Component);

Tabs.displayName = 'Tabs';
Tabs.propTypes = {
  /** The Tabs's content (Tab) */
  children: _propTypes2.default.node.isRequired,
  /** Override the styles of the root element */
  style: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  /** Override the styles of the tab container */
  tabContainerStyle: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  /** Override the styles of the tab content container */
  contentContainerStyle: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  /** Override the styles of the tab content container */
  contentStyle: _propTypes2.default.object, // eslint-disable-line react/forbid-prop-types
  /**
   * Specify initial visible tab index.
   * If `initialSelectedIndex` is set but larger than the total amount of specified tabs,
   * `initialSelectedIndex` will revert back to default.
   */
  initialSelectedIndex: _propTypes2.default.number,
  /**
   * Callback fired when Tab is switched
   *
   * function(event: object, value: string || number) => void
   */
  onTabChange: _propTypes2.default.func,
  /** Index of the selected Tab */
  selectedIndex: _propTypes2.default.number
};
Tabs.defaultProps = {
  style: {},
  tabContainerStyle: {},
  contentContainerStyle: {},
  contentStyle: {},
  initialSelectedIndex: 0,
  onTabChange: _noop2.default,
  selectedIndex: null
};
Tabs.contextTypes = {
  color: _propTypes2.default.string
};
exports.default = (0, _radium2.default)(Tabs);
module.exports = exports.default;