'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _forEach = require('lodash/forEach');

var _forEach2 = _interopRequireDefault(_forEach);

var _filter = require('lodash/filter');

var _filter2 = _interopRequireDefault(_filter);

var _colors = require('../settings/colors');

var _colors2 = _interopRequireDefault(_colors);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Theme = function Theme(color) {
  _classCallCheck(this, Theme);

  _initialiseProps.call(this);

  this.color = color;
  this.subscriptions = [];
};

var _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.setColor = function (color) {
    _this2.color = color;
    (0, _forEach2.default)(_this2.subscriptions, function (func) {
      return func(color);
    });
  };

  this.subscribe = function (listener) {
    _this2.subscriptions.push(listener);

    return function () {
      _this2.subscriptions = (0, _filter2.default)(_this2.subscriptions, function (item) {
        return item !== listener;
      });
    };
  };
};

var ThemeProvider = function (_Component) {
  _inherits(ThemeProvider, _Component);

  function ThemeProvider(props, context) {
    _classCallCheck(this, ThemeProvider);

    var _this = _possibleConstructorReturn(this, (ThemeProvider.__proto__ || Object.getPrototypeOf(ThemeProvider)).call(this, props, context));

    _this.theme = new Theme(props.color);
    return _this;
  }

  _createClass(ThemeProvider, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        theme: this.theme
      };
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.theme.setColor(nextProps.color);
    }
  }, {
    key: 'render',
    value: function render() {
      var children = this.props.children;


      return children;
    }
  }]);

  return ThemeProvider;
}(_react.Component);

ThemeProvider.displayName = 'ThemeProvider';
ThemeProvider.propTypes = {
  /** Your theme's color */
  color: _propTypes2.default.string,
  /** Children to apply theme color to  */
  children: _propTypes2.default.node.isRequired
};
ThemeProvider.defaultProps = {
  color: _colors2.default.theme
};
ThemeProvider.childContextTypes = {
  theme: _propTypes2.default.object // eslint-disable-line react/forbid-prop-types
};
exports.default = ThemeProvider;
module.exports = exports.default;