'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _get = require('lodash/get');

var _get2 = _interopRequireDefault(_get);

var _colors = require('../settings/colors');

var _colors2 = _interopRequireDefault(_colors);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var themeable = function themeable(options) {
  return function (ChildComponent) {
    var _class, _temp;

    return _temp = _class = function (_Component) {
      _inherits(ThemeableComponent, _Component);

      function ThemeableComponent(props, context) {
        _classCallCheck(this, ThemeableComponent);

        var _this = _possibleConstructorReturn(this, (ThemeableComponent.__proto__ || Object.getPrototypeOf(ThemeableComponent)).call(this, props, context));

        _this.setColor = function (color) {
          return _this.setState({ color: color });
        };

        _this.state = {
          color: (0, _get2.default)(context, 'theme.color') || _colors2.default.theme
        };
        return _this;
      }

      _createClass(ThemeableComponent, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
          var theme = this.context.theme;


          if (theme) {
            this.unsubscribe = theme.subscribe(this.setColor);
          }
        }
      }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
          var theme = this.context.theme;


          if (theme) {
            this.unsubscribe();
          }
        }
      }, {
        key: 'render',
        value: function render() {
          var color = this.state.color;

          var propName = options && options.propName || 'color';
          var customPropName = _defineProperty({}, propName, color);
          var combinedProps = _extends({}, customPropName, this.props);

          return _react2.default.createElement(ChildComponent, combinedProps);
        }
      }]);

      return ThemeableComponent;
    }(_react.Component), _class.contextTypes = {
      theme: _propTypes.PropTypes.object // eslint-disable-line react/forbid-prop-types
    }, _temp;
  };
};

exports.default = themeable;
module.exports = exports.default;